<template>
  <div>
    <nuxt-link
      class="fr-link fr-icon-arrow-left-line fr-link--icon-left fr-mb-6w"
      :to="{ name: 'services', query: $route.query }"
      >Retour à la liste</nuxt-link
    >

    <p class="fr-text--sm fr-mt-2w">
      Dernière mise à jour le {{ lastUpdateDate }}
    </p>

    <FrTitle class="fr-mb-6w" larger>{{ service.value }}</FrTitle>
    <div class="fr-mb-lg-6w fr-mb-2w fr-grid-row">
      <FrTitle tag="h2" class="fr-mb-0 fr-mr-2w">
        {{ service.name }}
      </FrTitle>

      <a
        v-if="service.url"
        class="fr-link fr-icon-arrow-right-line fr-link--icon-right fr-text--lg anct-link-no-underline fr-pt-1w"
        :href="service.url"
        target="_blank"
        title="Consulter le site du service"
        rel="noopener"
        @click="trackOutLink(service.url)"
        >Voir le site du service</a
      >
    </div>

    <FrTag
      v-if="service.stage"
      class="fr-mr-2w fr-mt-2w fr-mb-1w"
      :class="{
        'anct-bg-green anct-text-green': service.stage === 'Disponible',
        'fr-background-alt-grey anct-text-main': service.stage === 'En test',
      }"
      :label="service.stage"
    />
    <FrTag
      v-for="(theme, index) in [service.competence, ...service.themes]"
      :key="`service-tag--${index}`"
      class="fr-mr-2w fr-my-1w anct-text-blue anct-bg-blue--darker"
      :label="theme"
    />

    <div class="fr-my-6w">
      <FrExternalLinkButton
        v-if="customContactButton(service)"
        :href="customContactButton(service)"
        title="Contacter le service"
        >Contactez-nous</FrExternalLinkButton
      >
      <FrLinkButton
        v-else
        :to="{ name: 'contact' }"
        @click.native="trackContactClick"
        >Contactez-nous</FrLinkButton
      >
    </div>

    <img
      v-if="hasImage"
      :src="serviceImage"
      class="fr-responsive-img fr-col-10 fr-mb-6w anct-cropped-image"
      alt=""
    />

    <div>
      <FrAccordion
        v-if="service.description"
        id="description"
        v-model="accordion.description"
        title="Description"
        collapse-blue
      >
        <div
          class="fr-col-lg-8 fr-my-2w fr-px-2w fr-text--bold anct-html-content"
          v-html="service.description"
        ></div>
      </FrAccordion>

      <FrAccordion
        v-if="service.features && service.features.length"
        id="features"
        v-model="accordion.features"
        title="Les fonctionnalités"
      >
        <p>A quoi vous servira ce service ?</p>

        <FrCardsContainer>
          <FrCard
            v-for="(feature, index) in service.features"
            :key="`service-feature-card--${index}`"
            :description="feature.description"
            class="fr-mb-2w fr-col-10 fr-col-lg-3"
            no-arrow
          >
            <template v-if="feature.status" #start>
              <FrTag
                class="fr-text--xs anct-bg-transparent fr-px-0"
                :class="{
                  'anct-text-green': feature.status === 'Disponible',
                  'anct-text-main': feature.status === 'En test',
                }"
                :label="feature.status"
              />
            </template>

            <template #title>
              {{ feature.title }}
            </template>

            <template v-if="feature.status === 'En test'" #endDetail>
              <div class="anct-flex-end">
                <nuxt-link
                  :to="{ name: 'contact' }"
                  class="fr-link fr-icon-arrow-right-line fr-link--icon-right anct-link-no-underline"
                  >Je veux tester</nuxt-link
                >
              </div>
            </template>
          </FrCard>
        </FrCardsContainer>
      </FrAccordion>

      <FrAccordion
        v-if="service.target"
        id="territorial-level-target"
        v-model="accordion.territorialLevel"
        title="Les utilisateurs"
      >
        <p>A qui s'adresse ce service</p>

        <div class="fr-mb-2w fr-col-lg-8">
          <FrTag
            v-for="(level, index) in service.target"
            :key="`service-level-target-tag--${index}`"
            class="fr-mr-2w fr-mb-2w anct-text-blue anct-bg-blue--darker"
            :label="level"
          />
        </div>

        <p v-if="service.target_description" class="fr-col-lg-8">
          {{ service.target_description }}
        </p>
      </FrAccordion>

      <FrAccordion
        id="deploy"
        v-model="accordion.deploy"
        title="Comment mettre en place ce service ?"
        collapse-blue
      >
        <div class="fr-m-2w fr-px-2w">
          <div v-if="service.source_code_url">
            <a
              class="fr-fi--lg fr-fi-github-fill anct-link-no-underline anct-text-blue anct-link-no-target-decoration"
              :href="service.source_code_url"
              target="_blank"
              rel="noopener"
            ></a>
          </div>

          <p class="fr-col-lg-8 fr-my-2w">
            {{ contactText }}
          </p>

          <FrExternalLinkButton
            v-if="customContactButton()"
            :href="customContactButton()"
            title="Contacter le service"
            @click.native="trackContactClick"
            >Nous contacter</FrExternalLinkButton
          >
          <FrLinkButton
            v-else
            :to="{ name: 'contact' }"
            @click.native="trackContactClick"
            >Nous contacter</FrLinkButton
          >
        </div>
      </FrAccordion>

      <FrAccordion
        v-if="service.core_team || service.anct_team"
        id="teams"
        v-model="accordion.teams"
        title="Les équipes"
      >
        <div class="col-lg-8 fr-mb-2w">
          <FrTag
            v-for="(teamMember, index) in service.core_team"
            :key="`service-core-team-tag--${index}`"
            :label="teamMember"
            class="fr-mr-2w fr-text--md fr-mb-4w anct-text-blue anct-bg-blue--darker"
          />

          <template v-if="service.anct_team">
            <p><strong>Les expert de l'ANCT</strong></p>

            <FrTag
              v-for="(teamMember, index) in service.anct_team"
              :key="`service-anct-team-tag--${index}`"
              :label="teamMember"
              class="fr-mr-2w fr-text--md fr-mb-2w fr-background-alt--green-emeraude anct-text-green"
            />
          </template>
        </div>

        <a
          href="https://forum.incubateur.anct.gouv.fr"
          class="fr-btn fr-btn--ternary fr-text--md"
          target="_blank"
          title="Poser une question sue le site du Forum de l'Incubateur des Territoires"
          rel="noopener"
        >
          Posez une question sur le forum
        </a>
      </FrAccordion>

      <FrAccordion
        v-if="service.history"
        id="history"
        v-model="accordion.history"
        title="Un peu d’historique sur ce service"
      >
      </FrAccordion>

      <FrAccordion
        v-if="service.users"
        id="partners"
        v-model="accordion.partners"
        title="Les collectivités qui leur font confiance"
        collapse-blue
      >
        <div class="fr-m-2w">
          <FrTag
            v-for="(territory, index) in service.users"
            :key="`service-tag-partner--${index}`"
            class="fr-mr-2w fr-mb-2w anct-text-blue anct-bg-blue--darker"
            :label="territory"
          />
        </div>
      </FrAccordion>
    </div>
  </div>
</template>

<script>
import FrTitle from '~/components/ui/Title';
import FrTag from '~/components/ui/tags/Basic';
import FrLinkButton from '~/components/ui/LinkButton';
import FrExternalLinkButton from '~/components/ui/ExternalLinkButton';
import FrAccordion from '~/components/elements/Accordion';
import FrCard from '~/components/elements/Card';
import FrCardsContainer from '~/components/elements/CardsContainer';

export default {
  name: 'ServicePage',
  components: {
    FrExternalLinkButton,
    FrLinkButton,
    FrTitle,
    FrTag,
    FrAccordion,
    FrCard,
    FrCardsContainer,
  },

  async asyncData({ $axios, params, redirect, $config }) {
    const { data: serviceData } = await $axios.get('/items/services', {
      params: {
        filter: { slug: { _eq: params.slug } },
        fields: '*,images.directus_files_id',
      },
    });

    const [service] = serviceData.data;

    if (!service) {
      return redirect({ name: 'services' });
    }

    if (service.images) {
      service.images = service.images.map(
        (image) => `${$config.apiURL}/assets/${image.directus_files_id}`,
      );
    }

    const features = await Promise.all(
      service.features.map(async (featureId) => {
        const res = await $axios.get('/items/features', {
          params: { filter: { id: featureId } },
        });

        return res.data.data[0];
      }),
    );

    return {
      service: {
        ...service,
        features,
      },
    };
  },

  data() {
    return {
      accordion: {
        description: true,
        features: true,
        territorialLevel: false,
        deploy: false,
        teams: false,
        history: false,
        partners: false,
      },
    };
  },

  computed: {
    lastUpdateDate() {
      return new Date(
        this.service.date_updated || this.service.date_created,
      ).toLocaleDateString('fr', {
        day: 'numeric',
        month: 'short',
        year: 'numeric',
      });
    },
    hasImage() {
      return this.service.images && this.service.images.length;
    },
    serviceImage() {
      if (this.hasImage) {
        return this.service.images.at(0);
      }

      return null;
    },
    contactText() {
      if (this.service.program === "Startup d'Etat ou de territoires") {
        return (
          "Nous vous invitons à prendre contact avec l'équipe du " +
          'service qui vous proposera de participer à une démonstration/formation et \n' +
          'auprès de qui vous pourrez poser toutes vos questions.'
        );
      }
      return (
        'Nous vous invitons à prendre contact avec l’équipe de l’Incubateur \n' +
        'qui vous expliquera en détail les démarches à réaliser pour la mise en \n' +
        'place de ce service.'
      );
    },
  },

  methods: {
    customContactButton() {
      if (!this.service.program === "Startup d'Etat ou de territoires") {
        return null;
      }
      if (this.service.contact_form_url) {
        return this.service.contact_form_url;
      }
      if (this.service.contact_email) {
        return `mailto:${this.service.contact_email}`;
      }

      return null;
    },
  },
};
</script>

<style scoped>
/deep/ .anct-html-content blockquote {
  margin-left: 0;
  border-left: 4px solid var(--blue-france-main-525);
  padding-left: 16px;
}

/deep/ .anct-html-content blockquote p {
  margin-bottom: 0;
}

/deep/ .anct-html-content blockquote p strong {
  font-weight: normal;
}

/deep/ .anct-html-content ul,
/deep/ .anct-html-content ol {
  margin-left: 24px;
  margin-bottom: 16px;
}

/deep/ .anct-html-content ul p {
  margin-bottom: 8px;
}

/deep/ .anct-html-content h2 {
  margin-top: 48px;
}

.anct-cropped-image {
  object-fit: cover;
  max-height: 500px;
  object-position: top;
}
</style>
